﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.Net.Sockets;
using System.Diagnostics;

namespace BerkelyAlgorithem2
{
    class Slave
    {
        private RunningClock clock;
        private Neighbour master;
        private tcpServer ser;
        private tcpClient cli;
        private Neighbour self;
        public int offsetsum;
        public int offsetCounter;
        System.Threading.Thread clockThread;
        int timeout;
        public RunningClock driftClock;
        public bool firstSync = true;
        
        public Slave(NeighbourTable ntb, RunningClock clock,RunningClock driftClock)
        {
            offsetsum = 0;
            offsetCounter = 0;
            this.clock = clock;           
            this.master = ntb.getMaster();
            int myPortOffset = 0;

            this.driftClock = driftClock;


            timeout = 10000;
            //get myself
            foreach (Neighbour ne in ntb.Neighbours)
            {
                if (ne.Address.Equals(utils.FindLanAddress()))
                {
                    self = ne;
                }
            }

            
            myPortOffset = self.syncPort;

            //an error hapend and i did not find my self
            if (myPortOffset == 0)
            {
                throw new ArgumentNullException();
            }
           
            int attempt = 1;
            //console.WriteLine("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            //console.WriteLine(self.Address + " connectint on server " + master.Address + "at port " + (int)(myPortOffset + ntb.Neighbours.Count));
            //console.WriteLine("I WILL ATTEMPT TO CONNECT TO MASTER:"+master.Address.ToString()+":"+self.syncPort);
            //console.WriteLine(ntb.NeighbourAsString);
            //console.WriteLine("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
           
            //attempting to connect
            while (true)
            {
                try//to connect
                {
                    //console.WriteLine("\t"+self.Address + " is attempting to connect to server");
                    //creat server for getting messages from master
                    
                    ser = new tcpServer(IPAddress.Any, self.syncPort + ntb.Neighbours.Count);
                    //console.WriteLine("\tconnected");
                    break;
                }
                catch//faild to connect
                {
                    //console.WriteLine("\t" + self.Address + " faild to connent to the server");
                    if (attempt < 3)//try again, max 3 attemptes
                    {
                        attempt++;
                    }
                    else//attempted to connect 3 times and faild
                    {
                        //console.WriteLine("\t" + self.Address + " failed to connect to the server, exiting");
                        master.IsAlive = false;
                        throw new ElectionStartedException(master.Address.ToString(), master);
                    }

                }
            }
           
        }



        ~Slave()
        {
            ser.exit();
            if(cli!=null)
                cli.exit();
            GC.Collect();
            GC.WaitForPendingFinalizers();
        }

        public void start()
        {

            byte[] offset=null;
            bool bug=false;
            //tkura
            DateTime start=DateTime.Now;
            DateTime stop=DateTime.Now;

            //get message from master, expected !!! - start sync
            int mosh = 0;
            string msg = null;
            try
            {
                //console.WriteLine("in slave (getting !!!)");
               
                System.Threading.Thread testTCP;

                testTCP = new System.Threading.Thread(() => { msg = utils.ByteToStrArray(ser.getMsg()); });
                testTCP.Start();
                testTCP.Join(timeout);
                timeout = 500;
//note
                if(msg==null)
                {
                    //we did not rcv the msg...
                    //console.WriteLine("\tgetting message faild, exiting");
                    master.IsAlive = false;
                    throw new ElectionStartedException(master.Address.ToString(),master);
                }
                //msg = utils.ByteToStrArray(ser.getMsg());


            }
            catch
            {
                //console.WriteLine("\tgetting message faild, exiting");
                master.IsAlive = false;
               throw new ElectionStartedException(master.Address.ToString(),master);
            }
            

            int attempt = 1;
            //console.WriteLine(self.Address + " opening client");

            //open clinet for sending messages to master, ther are three attemptes
            while (true)
            {
                try
                {
                    //console.WriteLine("\t" + self.Address + " is attempting to creat client");
                    cli = new tcpClient(master.Address, self.syncPort);
                    //console.WriteLine("\t connected");
                    break;
                }
                catch//faild to creat client
                {
                    //console.WriteLine("\t" + self.Address + " faild to connent");
                    if (attempt < 3)//try again
                    {
                        attempt++;
                    }
                    else//faild three times exiting...
                    {
                        //console.WriteLine("\t" + self.Address + " failed to connect, exiting");
                        master.IsAlive = false;
                       throw new ElectionStartedException(master.Address.ToString(),master);
                    }

                }
            }

            //sync in loop
            Console.WriteLine("SyncdClock\tsteadyClock");
            while (true)
            {
                //console.WriteLine("in slave.start():: \n\t(start sync) slave recived msg: \"" + msg + "\"");
               

                if (msg.Equals("!!!"))//if i got sync message
                {
                    try//try to sean the master my time
                    {

                        cli.sendMsg(clock.getTime());
                        //stop = DateTime.Now;
                        ////console.WriteLine("*&*&*&*&*&*&*&*&*&*");
                        ////console.WriteLine("TKURA OF SLAVE=\t"+(int)utils.subDateTimesGetTotMS(stop,start));
                        ////console.WriteLine("*&*&*&*&*&*&*&*&*&*");
                    }
                    catch//faild to send to master my time
                    {
                        //console.WriteLine("\tgetting message faild, exiting");
                        master.IsAlive = false;
                       throw new ElectionStartedException(master.Address.ToString(),master);
                    }
                    //console.WriteLine("\tslave sent msg (my time):\" " + clock.getTime() + "\"");
                }

                try
                {
                    offset = ser.getMsg();
                }
                catch
                {
                    //console.WriteLine("\tgetting message faild, exiting");
                    master.IsAlive = false;

                    throw new ElectionStartedException(master.Address.ToString(), master);
                }


                string srtOffset = utils.ByteToStrArray(offset);
                
                //tcp bug...
                if (srtOffset.Contains('!'))
                {
                    bug = true;
                    srtOffset = srtOffset.Split('!')[0];
                }

                //console.WriteLine("\tstr offset: " + srtOffset);
                int intOffset = 0;

               
                try
                {
                    intOffset = int.Parse(srtOffset);
                }
                catch
                {
                    //console.WriteLine("\tparsint offset faild, exiting");
                    master.IsAlive = false;
                   throw new ElectionStartedException(master.Address.ToString(),master);
                }
                offsetsum += Math.Abs(intOffset);
                offsetCounter++;
                //console.WriteLine("offset avr = " + (offsetsum / offsetCounter));
                clock.setTime(intOffset);

                if (firstSync)
                    driftClock.setTime(utils.DateTimeAsString(clock.CurrentTime).Split(':'));
                firstSync = false;

                //=-========================
                
                Console.Write(utils.getTimeInMS(utils.DateTimeAsString(clock.CurrentTime).Split(':')) + "\t" + utils.getTimeInMS(utils.DateTimeAsString(driftClock.CurrentTime).Split(':')));
                Console.WriteLine();
                //==========================


                //console.WriteLine("\tslave's time after adding offet is:" + clock.getTime());

                try
                {
                    if (!bug)
                        msg = utils.ByteToStrArray(ser.getMsg());
                    else
                    {
                        msg = "!!!";
                        bug = false;
                    }
                }
                catch
                {
                    //console.WriteLine("\tgetting message faild, exiting");
                    master.IsAlive = false;
                    throw new ElectionStartedException(master.Address.ToString(),master);
                }
                //start = DateTime.Now;

            }
        }

        private void testtccp(object obj)
        {
            System.Threading.Thread.Sleep(5000);
            master.IsAlive = false;
            throw new ElectionStartedException(master.Address.ToString(), master);
        }
    }
}
